
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Linux Linux程序练习十四（多进程压力测试） / 憋错料</title>

    <meta name="description" content="Linux Linux程序练习十四（多进程压力测试） /* * 题目: * 编程一个基本多进程测试框架,提示用户输入进程数.和每个进程数运行圈数.(fork) * 进行多进程压力测试.(execve) * 要求父进程能监控所有子进程的退出,避免僵尸进程.(wait) * */ #include &lt;stdio.h&gt; #include &lt;stdlib.h&gt; #include &lt;string.h&gt; #include &lt;unistd.h&gt; #include &lt;errno.h&gt; #include & ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Linux Linux程序练习十四（多进程压力测试）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>/*
 * 题目：
 * 编程一个基本多进程测试框架，提示用户输入进程数、和每个进程数运行圈数。(fork)
 * 进行多进程压力测试。(execve)
 * 要求父进程能监控所有子进程的退出，避免僵尸进程。(wait)
 * */
#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#include &lt;unistd.h&gt;
#include &lt;errno.h&gt;
#include &lt;sys/types.h&gt;
#include &lt;sys/wait.h&gt;

int main(int arg, char *args[])
{
    if (arg &lt; 2)
    {
        printf("please print pid num !\n");
        return -1;
    }
    int pidnum = atoi(args[1]);
    int pid = 0;
    while (pidnum--)
    {
        pid = fork();
        if (pid &lt; 0)
        {
            printf("fork() failed !\n");
            break;
        }
        if (pid == 0)
        {
            //执行测试程序
            execl("./runc", "./runc", NULL);
        }
    }
    int status = 0, ret = 0;
    while (1)
    {
        ret = wait(&amp;status);
        printf("子进程pid=%d\n", ret);
        if (ret == -1)
        {
            //屏蔽其他信号
            if (errno == EINTR)
            {
                continue;
            }
            break;
        }
    }
    printf("game is over !\n");
    return 0;
}</pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzMjAxNS5jbmJsb2dzLmNvbS9ibG9nLzY0NDc0My8yMDE2MTEvNjQ0NzQzLTIwMTYxMTMwMjI1NzQ5MTE1LTI4NjI5Nzg2My5wbmc=.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 11:57:17 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/alt/" title="alt">alt</a>, <a href="https://www.biecuoliao.com/tag/div/" title="div">div</a>, <a href="https://www.biecuoliao.com/tag/src/" title="src">src</a>, <a href="https://www.biecuoliao.com/tag/amp/" title="amp">amp</a>, <a href="https://www.biecuoliao.com/tag/include/" title="include">include</a>, <a href="https://www.biecuoliao.com/tag/while/" title="while">while</a>, <a href="https://www.biecuoliao.com/tag/bre/" title="bre">bre</a>, <a href="https://www.biecuoliao.com/tag/types/" title="types">types</a>, <a href="https://www.biecuoliao.com/tag/%e5%83%b5%e5%b0%b8%e8%bf%9b%e7%a8%8b/" title="僵尸进程">僵尸进程</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Linux Linux程序练习十四（多进程压力测试）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bKN2o3.html" rel="bookmark">嵌入式Linux裸机开发（十四）&mdash;&mdash;ADC</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				嵌入式Linux裸机开发(十四)--ADC 一.AD转换简介 AD转换就是模数转换,就是把模拟信号转换成数字信号.A/D转换器是用来通过一定的电路将模拟量转变为数字量.模拟量可以是电压.电流等电信号,也可以是压力.温度.湿度.位移.声音等非电信号.在A/D转换前,输入到A/D转换器的输入信号必须经各种传感器把各种物理量转换成电压信号.A/D转换后,输出的数字信号可以有8位.10位.12位.14位和16位等. 二.ADC控制器 ADC控制器时钟: 时钟源为PCLK_PSYS,经过一次分频后得到AD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kLLv73.html" rel="bookmark">Linux内核分析 - 网络&lbrack;十四&rsqb;：IP选项</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux内核分析 - 网络[十四]:IP选项 标签: linux内核网络structsocketdst 2012-04-25 17:14 5639人阅读 评论(1) 收藏 举报  分类: 内核协议栈(22)  版权声明:本文为博主原创文章,未经博主允许不得转载. 内核版本:2.6.34      在发送报文时,可以调用函数setsockopt()来设置相应的选项,本文主要分析IP选项的生成,发送以及接收所执行的流程,选取了LSRR为例子进行说明,主要分为选项的生成.选项的转发.选项的接收三部分			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02mjdEM.html" rel="bookmark">在linux中给你的应用做压力测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在linux中给你的应用做压力测试 作者: 立地 邮箱: [email protected] QQ: 511363759 一.webbench 1.在Ubuntu中安装webbench —支持get,head等请求,但不支持post请求 wget http://blog.zyan.cc/soft/linux/webbench/webbench-1.5.tar.gz tar zxvf webbench-1.5.tar.gz cd webbench-1.5 make &amp;&amp; make insta			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPb7gy3.html" rel="bookmark">十大网站压力测试工具</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				两天,jnj在本站发布了&lt;如何在低速率网络中测试 Web 应用&gt;,那是测试网络不好的情况.而下面是十个免费的可以用来进行Web的负载/压力测试的工具,这样,你就可以知道你的服务器以及你的WEB应用能够顶得住多少的并发量,以及你的网站的性能.我相信,北京奥组委的订票网站的开发团队并不知道有这样的测试工具. Grinder –  Grinder是一个开源的JVM负载测试框架,它通过很多负载注射器来为分布式测试提供了便利. 支持用于执行测试脚本的Jython脚本引擎HTTP测试可通过HTTP代理进行			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xvgPz4.html" rel="bookmark">linux学习笔记-第十四课-日常管理（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.w和uptime [[email protected] ~]# w  20:29:01 up 28 min,  1 user,  load average: 0.00, 0.00, 0.00 USER     TTY      FROM              [email protected]   IDLE   JCPU   PCPU WHAT mylinux  pts/0    192.168.1.105    20:12    0.00s  0.32s  0.26s sshd: my			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Myw9zj3.html" rel="bookmark">linux架构学习第二十四天-DNS详解及bind搭建各种DNS测试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内容: 一.DNS 1.域名系统概述 2.域名的结构 3.域名服务器 4.域名解析过程 5.域名服务器的资源记录(resource record RR) 二.bind搭建DNS服务器 1.bind的安装 2.搭建DNS服务器 3.搭建主从DNS服务器 4.实现DNS子域 5.实现DNS视图view(智能DNS) 一.DNS 1.域名系统概述 域名系统DNS(Domain Name System)是因特网使用的命名系统,用来把便于人们使用的机器名字转换成为IP地址.域名系统其实就是名字系统.为什么			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e26mw3.html" rel="bookmark">Linux学习笔记（十四）df命令、du命令、磁盘分区</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.df #查看文件系统的使用情况第一列文件系统中tmpfs结尾的都是临时的文件系统,文件单位默认为kb df -h 自动适应文件大小的单位free可以查看swap的使用情况 df -i 查看各个分区inode的使用情况有的时候明明磁盘的内存还有剩余,但是却无法写入新文件,这时候就可能是inode用完了. 二.du 查看文件大小 du -sh 自动适应单位显示文件或文件夹大小 du不加后缀的时候和du -l 一样,显示文件夹下文件的大小 du -lh 自动适应单位显示文件夹下文件的大小 三.磁盘			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MD6mA83.html" rel="bookmark">Linux学习笔记（十四）--命令学习（vi的基本使用）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本博客中linux大部分内容是参考:鸟哥的私房菜     如各位有需要的,请参考:http://vbird.dic.ksu.edu.tw/linux_basic/linux_basic.php 上面我们已经知道了大部分Linux基本内容 1.查看系统信息 2.文件与目录查看 3.文件创建 4.文件权限属性 5.用户创建与删除 6.压缩包的打包与解包 现在要进行文件编辑等操作的学习. Linux 中,绝大部分的配置文件都是以 ASCII 的纯文本形态存在,因此利用简单的文字编辑软件就能够修改设定了			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02aWlBM.html" rel="bookmark">Linux学习总结（十四） 文件的打包和压缩</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文件的压缩和打包,在windos下我们很熟悉.rar和.zip文件,这是两种压缩文件,他们支持单个文件和多个文件的压缩.windos下我们不提及打包的概念,虽然多个文件的压缩肯定存在打包过程.打包和压缩的区别,从字面意思就可以看出,打包是将多个文件捆绑到一起,目的是方便拷贝和传输,压缩通常是对打包后的再处理,目的是节省资源,比如节省网络带宽,提高传输效率.从以上结论中,我们就能理解为什么linux会有如此多的打包压缩工具,windos要求操作尽可能简单,linux要求高效和控制力.几种打包压缩工			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMXR7X3.html" rel="bookmark" class="title">Python学习记录-2016-11-30</a>
					<div>
						今日内容: 猜年龄游戏和游戏优化: 依照上次代码: age = 22 guess_num = int(input(&quot;input your guess number:&quot;)) if g ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz8V2q3.html" rel="bookmark" class="title">python学习随笔</a>
					<div>
						费解,同样安装python27,实验室的电脑上图形界面可以打开,自己的电脑怎么弄都打不开.看来还是太弱鸡. **************python容器类型***************** list ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3O78mo3.html" rel="bookmark" class="title">iframe动态创建及释放内存</a>
					<div>
						最近参与一个项目的开发,由于项目是基于浏览器的胖客户端(RIA)应用程序,页面中大量调用iframe.后期测试发现浏览器内存一直居高不下,而且打开iframe页面越多内存占用越大,在IE系列浏览器中尤 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGzjoM.html" rel="bookmark" class="title">python各种库、框架的安装和卸载</a>
					<div>
						才疏学浅,努力深入,逐步更新,有问题敬请留言告知,谢谢. 关于python第三方库的安装最好少使用 easy_install,因为 easy_install 只能安装不能卸载,如果要卸载需要进入到 p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Naoz83.html" rel="bookmark" class="title">angular 指令   要点解析</a>
					<div>
						指令可以删繁就简前端的js代码,杜绝重复的js代码和html代码. 下面就对指令的重要属性进行罗列 一.restrict  =  'AEC'  分别指该指令标识位于attribute属性.elemen ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomKZP3.html" rel="bookmark" class="title">将当前屏幕保存为图片</a>
					<div>
						今天在修改登陆界面时有个需求,点击登陆按钮要求以渐显得方式弹出登录窗口,窗口居中,窗口周围以半透明方式显示上个控制器的图片.于是用到了模态推出的以下方法. controller.modalTransi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmAdg1M.html" rel="bookmark" class="title">tornado 之 图片验证码</a>
					<div>
						生成图片的验证码,进行图像处理,需使用Pillow 1 #!/usr/bin/env python 2 #coding:utf-8 3 4 import os 5 import random 6 fr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qaXy53.html" rel="bookmark" class="title">java 获取当月第一天和最后一天 获取前一个月第一天和最后一天</a>
					<div>
						第一种: public static void main(String[] args) { SimpleDateFormat format = new SimpleDateFormat(&quot;y ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wWDRZ3.html" rel="bookmark" class="title">lamp 模块化&plus;vsftd&plus;samba</a>
					<div>
						领导看了之后,说你也试试php和ftp在同一个机器上,另外给你一台机器做samba和ftp让大家放点资料:同时我希望你详细了解vftpd配置文件的基本意思,做共享的时候领导和特殊岗位是有写权限的. 一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyWzVL3.html" rel="bookmark" class="title">iOS静态库小结</a>
					<div>
						准备知识: 1.什么是库? 库是程序代码的集合,是共享程序代码的一种方式 2.根据源代码的公开情况,库可以分为2种类型 a.开源库 公开源代码,能看到具体实现 ,比如SDWebImage.AFNetw ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KOnZj0.html" rel="bookmark" class="title">weblogic  Cause&colon; org&period;hibernate&period;exception&period;GenericJDBCException&colon; Connection closed</a>
					<div>
						现场的weblogic报错,导致数据无法下发,报错信息如下: ### Error opening session.  Cause: org.hibernate.exception.GenericJDB ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41DkPq3.html" rel="bookmark" class="title">linux &plus; export</a>
					<div>
						参考别人的:没整理(不好意思啦~) “/bin”.“/sbin”.“ /usr/bin”.“/usr/sbin”.“/usr/local/bin”等路径已经在系统环境变量中了,如果可执行文件在这几个标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnoE80.html" rel="bookmark" class="title">Go数据结构之Queue</a>
					<div>
						Queue 简单而实用的数据结构,FIFO,通过循环数组避免队列出现&quot;似乎满了&quot;的现象. package Queue import &quot;errors&quot; const ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wBvmN0.html" rel="bookmark" class="title">js或者ext js获取返回值</a>
					<div>
						  由于前台业务需要在判断中发起ajax到后台,根据返回值校验是否通过 代码如下 关键点在于要将async关闭 设置成同步,这样才能接收到要返回的flag                        ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AWx6z0.html" rel="bookmark" class="title">刷新加载1</a>
					<div>
						/** * @file XListView.java * @package me.maxwin.view * @create Mar 18, 2012 6:28:41 PM * @author Max ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xeWDQ3.html" rel="bookmark" class="title">RTMP、RTSP、HTTP视频协议详解（附：直播流地址、播放软件）</a>
					<div>
						一.RTMP.RTSP.HTTP协议 这三个协议都属于互联网 TCP/IP 五层体系结构中应用层的协议.理论上这三种都可以用来做视频直播或点播.但通常来说,直播一般用 RTMP.RTSP.而点播用 H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmPnKM.html" rel="bookmark" class="title">斯坦福大学Andrew Ng - 机器学习笔记（3） -- 神经网络模型</a>
					<div>
						大概用了一个月,Andrew Ng老师的机器学习视频断断续续看完了,以下是个人学习笔记,入门级别,权当总结.笔记难免有遗漏和误解,欢迎讨论. 鸣谢:中国海洋大学黄海广博士提供课程视频和个人笔记,在此深 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dEROw3.html" rel="bookmark" class="title">同一个磁盘中从根分区缩小空间到扩展SWAP分区空间实践步骤</a>
					<div>
						操作背景: 公司中有一部分主机在开始设计的时候,并未考虑到SWAP的大小,只是分配了物理内存的2倍-4G,导致后期应用部署完成后对系统的SWAP分区要求达不到标准.因此经过部分和领导讨论后,决定在同一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49OgEg0.html" rel="bookmark" class="title">关于MATLAB中的tic toc的问题</a>
					<div>
						关于MATLAB中的tic toc的问题 其一) MATLAB实际单位时间计时函数的具体应用,在编写程序时,经常需要获知代码的执行实际时间,这就需要在程序中用到计时函数,matlab中提供了以下三种方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dDkxZ0.html" rel="bookmark" class="title">【selenium】HTMLTestRunner测试报告生成</a>
					<div>
						__author__ = 'Administrator' #coding=utf-8 from selenium import webdriver from selenium.webdriver.co ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
